<template>
    <div>
        <Discount :data="textEditor" />
        <div class="discount-group edit__set_block">
            <div class="full-width">
                <div class="form-title">
                    <b>Logo</b>
                </div>
                <div><b>Logo image</b></div>
                <div class="dropzone-container">
                    <VueDropzone
                        id="dropzone"
                        ref="dropzone"
                        :options="dropzoneOptions"
                        class="dz-clickable text-center"
                        :destroy-dropzone="false"
                        @vdropzone-removed-file="removeFile"
                        @vdropzone-mounted="setFile"
                        @vdropzone-success="updatePreview"
                    >
                        <div class="dz-default dz-message" />
                    </VueDropzone>
                </div>
            </div>
        </div>
        <div class="discount-group edit__set_block">
            <div class="row">
                <div class="col-md-4 form-title">
                    <b>Content</b>
                </div>
                <div class="col-md-8 text-right">
                    <b-select
                        v-model="selectedTagMenu"
                        class="form-control select-tags"
                        @change="addText"
                    >
                        <option
                            v-for="(menu, index) in selectTagMenus"
                            :key="index"
                            :value="menu.title"
                        >
                            {{ menu.title }}
                        </option>
                    </b-select>
                </div>
            </div>
            <validation-provider
                v-slot="validationContext"
                name="Headline"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Headline</b>
                    </div>
                    <b-form-input
                        v-model="textEditor.title"
                        type="text"
                        class="my-input full-width"
                        name="title"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="Body Text"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Body Text</b>
                    </div>
                    <b-form-input
                        v-model="textEditor.text"
                        class="form-control my-input full-width"
                        name="text"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="URL"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>URL</b>
                    </div>
                    <b-form-input
                        v-model="textEditor.url"
                        type="text"
                        class="form-control my-input full-width"
                        name="url"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
        </div>
    </div>
</template>

<script>
import VueDropzone from "vue2-dropzone";
import 'vue2-dropzone/dist/vue2Dropzone.min.css';
import headers from "../../../../helpers/authHeader";
import link from "../../../../helpers/backLink";
import Discount from '@/components/edit/Discount.vue'
export default {
    name: "TextEditor",
    components: {
        VueDropzone,
        Discount
    },
    mixins: [headers, link],
    props: ['textEditor', 'errors'],
    data() {
        return {
            dropzoneOptions: {
                url: this.getSegment()  + '/push/welcome/picture/',
                thumbnailWidth: 120,
                headers: {Authorization: `Bearer ${$cookies.get('userToken')}`},
                thumbnailHeight: 120,
                maxFiles: 1,
                maxFilesize: 0.512,
                addRemoveLinks: true,
                acceptedFiles: "image/jpeg,image/png",
                dictRemoveFile: 'Remove',
                dictDefaultMessage: '<div style="border: 1px dotted rgba(138, 135, 135, 0.36);\n' +
                    '    display: inline-block;\n' +
                    '    padding: 10px 20px 10px 40px;">' +
                    '<span class="mb-20">' +
                    '<img style="max-width:40px; margin-left: -20px;margin-right: 20px" src="/images/cart-icon-new.png">' +
                    '</span><b>Upload your logo image</b></div>'
            },
            selectTagMenus: [
                {
                    title: 'tags'
                },
                {
                    title: '{siteName}'
                },
                {
                    title: '{discountValue}'
                },
                {
                    title: '{discountCode}'
                },
                {
                    title: '{storeEmail}'
                },

            ],
            selectedTagMenu: 'tags',
            focusedInput: 0,
            focusedName: '',
        }
    },
    methods: {
        addText() {
            const len = this.textEditor[this.focusedName].length
            const before = this.textEditor[this.focusedName].substr(0, this.focusedInput)
            const after = this.textEditor[this.focusedName].substr(this.focusedInput, len)
            this.textEditor[this.focusedName] = before + this.selectedTagMenu + after
            this.focusedInput += this.selectedTagMenu.length
            this.selectedTagMenu = 'tags'
        },
        getValidationState({dirty, validated, valid = null}) {
            return dirty || validated ? valid : null;
        },

        focus(e) {
            this.focusedInput = e.target.selectionStart
            this.focusedName = e.target.name
        },
        removeFile() {
            axios.delete(this.getSegment()+'/push/welcome/picture/', this.getUserHeader())
                .then(response => {
                    this.textEditor.logo = null;
                });
        },
        setFile() {
            let file = {size: 0, name: "Icon", type: "image/jpeg"};
            let url = this.textEditor.logo;
            if (url) {
                this.$refs.dropzone.manuallyAddFile(file, url);
            }
        },
        updatePreview(file, response) {
            this.textEditor.logo = response;
        },
    }
}
</script>

<style scoped>
.discount-help-text {
    margin-bottom: 0;
}

</style>
